
        Device = 16F877A
        Xtal = 8

'--------------------------   --------------------
                                                                   
Config  DEBUG_OFF, WRT_OFF, CPD_OFF, LVP_OFF, BODEN_OFF, PWRTE_OFF, WDT_OFF, HS_OSC 


'  
		
Dim n  As Byte        '   
Dim t As Byte         '      
Dim Perem As Byte          '      
Dim Pusk As Perem.0       '   
Dim Napr As Perem.1       '   . - (1)  - (0)
Dim Konec As Perem.2     '   
Dim Pr_k As Perem.3      '    USART
Dim A As Byte         '   
Dim Reg As Byte       '  
Dim U_a As Word       '   
Dim U1 As Word        '    
Dim U2 As Word        '     
Dim Tok_k As Byte     '     
Dim T_imp As Byte     '   
Dim T_paus As Byte    '     
Dim Dekr As Byte      '  
Dim Par As Bit
Dim Tik As Byte        '  . 1  = 40 
Dim Sek As Byte        '  
Dim Minut As Byte      '  
'Dim Err As Byte        '  
Dim vrT As Word        '   
           
Dim out_Ur As Word     '    
Dim Duty As Byte       '      
'                           
Dim Duty_1 As Byte     '       

Dim TrTmr As Byte      '   (   )

'Symbol Timer TMR0      '      TMR0

TRISB.2 = 0            ' -
TRISB.3 = 0            '  |-   
TRISD.2 = 0            '  |
TRISD.3 = 0            ' -

TRISB.4 = 1
TRISB.5 = 1
TRISC.1 = 0
TRISC.2 = 0
TRISC.5 = 0
TRISB.1 = 0

;--------------------------  USART -------------------------- 
Declare Hserial_Baud 9600 ;   ,  
Declare Hserial_RCSTA = %10010000  ' Enable serial port and continuous receive 
Declare Hserial_TXSTA = %00100000  ' Enable transmit and asynchronous mode  
'Declare Hserial_SPBRG 6 ;   SPBRG   
Declare Hserial_Clear = On ;         

'  
Declare Adin_Res = 10 					' 12-bit ADC result required 
Declare Adin_Tad = 32_FOSC 					' RC OSC chosen 
Declare Adin_Stime = 50 				' Allow 50us sample time 
'   AN0 (PORTA.0)  AN1 (PORTA.1)  
TRISA = %000111         
'    PORTA.0  PORTA.1     
ADCON1 = %10000000       

Declare Create_Coff = On	    
		
'Optimiser_Level = 3

'-----------------------------------------
'     .0   0
'----------------------------------------------------------------------

'INTCON.5 = 1     '     0

'--------------------------------------
'  
'------------------------------------
OPTION_REG = %10010111        '   
        '        B0
        '    1- , 0-  F/4
        '
        '    /128
        '

On_Hardware_Interrupt GoTo  Prer
'Symbol Vremja TMR0

PORTB.2 = 0
PORTD.2 = 1
PORTB.3 = 0
PORTD.3 = 1
'PORTC.2 = 0
PORTB.1 = 0
PORTC.5 = 0
Reg = 0
A = 0
U_a = 2
Tik = 0
Sek = 0
Minut = 0
Duty = 100
Duty_1 = 1
vrT = 0
Pusk = 0
Napr = 0
TrTmr = 0
Konec = 0
'INTCON.7 = 1:     '   
INTCON.6 = 1      '   
PIE1.5 = 1        '     USART
'DelayMS 1500

GoTo Main

'*****************************
'   
'***************************
Prer:
Context Save 
If PIR1.5 = 1 Then                           
HSerIn 1,Main,[Perem, Reg]       
EndIf
Context Restore                
INTCON.7 = 0

Resume

'********************************************
'   
'  5 . 1-; 21-.-; 22-.-; 3-;
' 4-; 
'*****************************************

Main:

 INTCON.7 = 1
If Reg = 1 Then GoTo Komp
GoTo Main
'***********************************
'    
'***********************************
Komp:             '   

If Pusk = 0 Then
  HPWM 1, 10, 1000           '     
  DelayMS 50
  PORTB.1 = 0                ' .  

EndIf
If Pusk = 1 Then
 Konec = 1
 U1 = Tok_k '* 2 
 U2 = Tok_k /10
 HPWM 1, 255, 1000 
 GoSub Rabota
EndIf
 
If Reg <> 1 Then GoTo Main
GoTo Komp 

'***********************************
'  
'****************************
 Rabota:
   If Napr = 1 Then
   PORTB.2 = 1
   PORTD.2 = 0
   PORTB.3 = 0
   PORTD.3 = 1
   
   Else
   PORTB.2 = 0
   PORTD.2 = 1
   PORTB.3 = 1
   PORTD.3 = 0
  EndIf
  HPWM 2, 255, 2000          '  
  DelayMS 50
  PORTB.1 = 1                ' .  
  Konec = 1
  GoSub RS232_out
  HPWM 1, 255, 1000        '      
  Repeat
  GoSub Ism
  If t = 0 Then GoSub RS232_out
  'If t = 31 Then GoSub RS232_out
  Until Pusk = 0 Or Pr_k = 1  
  'If Pr_k = 1 Then GoSub Rs232_in
  If Pusk = 0 Then
   PORTB.1 = 0                ' .  
   Konec = 0
   DelayMS 100
   GoSub Ism
   GoSub RS232_out
   EndIf
 If Reg = 1 Then GoTo Komp
 GoTo Rabota
   
'*****************************
'    
'*****************************
Ism:
  U_a = ADIn 0                   '  
  U_a =  U_a * 10
  A = U_a / 47
 
 Return

'*****************************
'    
'*****************************
'  
Rs232_in:
PORTC.5 = 0
HSerIn [Perem, Reg, Dekr, Tok_k, T_imp, T_paus]
DelayMS 1
'If Err <> 0 Then GoTo Err1
Return

'  
RS232_out: 
PORTC.5 = 1
DelayUS 5
HSerOut [A, Perem]
DelayMS 5
PORTC.5 = 0
Return

