
        Device = 16F877A
        Xtal = 8

'--------------------------   --------------------
                                                                   
Config  DEBUG_OFF, WRT_OFF, CPD_OFF, LVP_OFF, BODEN_OFF, PWRTE_OFF, WDT_OFF, HS_OSC 

'  
		
Dim Perem As Byte          '      
Dim Pusk As Perem.0       '   
Dim Napr As Perem.1       '   . - (1)  - (0)
Dim Konec As Perem.2     '   
Dim Pr_k As Perem.3      '    USART
Dim n  As Byte             '   
Dim t As Byte              '      
Dim Key As Byte             '   
Dim A As Byte              '   
Dim Reg As Byte             ' 
Dim Tok_k As Byte         '     
Dim T_imp As Byte           '   
Dim T_paus As Byte          '     
Dim Dekr As Byte            '  
'Dim Err As Byte           '   
    
Dim minut As Byte         '   
Dim sek As Byte           '   
Dim T_i_p As Byte          '    

'           
Symbol   Ver3   PORTD.1   '   A, 
Symbol   HorB   PORTD.6   '   B, 
Symbol   HorC   PORTD.5   '   C, 
Symbol   HorD   PORTD.3   '   D, 
Symbol   Ver1   PORTD.2   '   1, 
Symbol   Ver2   PORTD.0   '   2, 
Symbol   HorA   PORTD.4   '   3,  

Declare Create_Coff = On

TRISD.0 = 1
TRISD.1 = 1
TRISD.2 = 1
TRISD.3 = 0
TRISD.4 = 0
TRISD.5 = 0
TRISD.6 = 0
TRISD.7 = 0
'PORTD = 1

'TRISC.6 = 0
TRISC.5 = 0
'TRISC.7 = 1

'                              
Declare LCD_DTPin PORTB.4
Declare LCD_RSPin PORTB.2
Declare LCD_ENPin PORTB.3
Declare LCD_Interface 4
Declare LCD_Lines 4

PORTB.1 = 0                       '  
TRISB = 0

;--------------------------  USART -------------------------- 
Declare Hserial_Baud 9600 ;   ,  
Declare Hserial_RCSTA = %10010000  ' Enable serial port and continuous receive 
Declare Hserial_TXSTA = %00100000  ' Enable transmit and asynchronous mode  
'Declare Hserial_SPBRG 6 ;   SPBRG   
'Declare Hserial_Clear = On ;         

'--------------------------------------
'  
'------------------------------------
 OPTION_REG = %10010111        '   
        '        B0
        '    1- , 0-  F/4
        '
        '    /256
        


PIE1.5 = 1        '     USART

On_Hardware_Interrupt GoTo  Prer

'PORTC.5 = 0
Pusk = 0
Konec = 0
Reg = 1
A = 150
Napr = 1             
Tok_k = 100
T_imp = 4
T_paus = 1
Dekr = 10
'Err = 0
minut = 0 
sek = 0
t = 0
T_i_p = 0
'DelayMS 500
Print $FE,$2A       '   
Cls

GoTo format

'*****************************
'   
'***************************
Prer:
Context Save 
If PIR1.5 = 1 Then
 HSerIn [A, Perem]            ' Pr_k = 1  '     UART
EndIf
If INTCON.5 = 1 And INTCON.2 = 1 Then
 Inc t
 If t = 32 Then
 Inc sek: t = 0:
 If Reg = 31 Or Reg = 32 Or Reg = 42 Then
  T_i_p = T_i_p + 1
  EndIf
 If sek = 60 Then sek = 0: minut = minut + 1
 If minut = 60 Then minut = 0
 EndIf
EndIf
INTCON.2 = 0
Context Restore                '    

INTCON.7 = 1
'Enable
Resume

'********************************************
'   
'*****************************************

'**************************************************
'      
'***************************************************
format:
Cls
INTCON.7 = 1:     '   
format1:
Print At 1,2,"Bòepe pe"                         '
                           '  
Print At 2,1,"1-Koeca"             ' 1-
Print At 3,1,"2-Paaae"         ' 2-
Print At 4,1,"3-Ooopù"            ' 3-

Repeat
GoSub KeyPad
Until  Key = 1 Or Key = 2 Or Key = 3 
DelayMS 260

If Key = 1 Then Reg = 1: Cls: GoTo Komp
'If Key = 2 Then GoTo Rasmag        
If Key = 3 Then Reg = 3': GoTo Odn
GoTo format1


'  5 . 1-; 21-. ; 22-.  ; 31-.  ;
' 32-.  ;41- ; 42- ; 
'*****************************
'   
'****************************
Komp:
Cls
k1: 
If Pusk = 0 Then
 t = 0: sek = 0: minut = 0
 Print At 1,1,"Pe oeca常"               '" 
 Print At 2,1,"To o.- ": Print At 2,16,"A (1)"
 Print At 2,12,Dec Tok_k
 Print At 3,1, "Hap. oa-      (0)"   '". - (0)
 If Napr = 1 Then 
   Print At 3,14,">"
   Else 
   Print At 3,14,"<"
 EndIf
 Print At 4,14,"#-Bxo"
 Print At 4,1,"yc-5"
EndIf
If Pusk = 1 And Konec = 0 Then 
  GoSub RS232_out
  INTCON.6 = 1      '   
  GoTo k1
EndIf
If Pusk = 1 And Konec = 1 Then
 Cls
 Print At 1,3,"Koeca"          ' ""
 Print At 2,5,"Paoa"     '""
 Print At 3,1,"I=     A"
 Print At 3,14,"T=  ."
 Print At 4,1,"Co-5"
                   
 If Konec = 1 Then INTCON.5 = 1: GoTo Rabota  '         
 ' konec = 1,         . ""
EndIf    
Repeat
GoSub KeyPad
Until  Key = 0 Or Key = 1 Or Key = 5 Or Key = 11 Or Konec = 1
DelayMS 260
'   
If Key = 5 Then Key = 12: Inc Pusk: 'Cls: GoTo k1
If Pusk = 0 Then
 n = 0: sek = 0: minut = 0: INTCON.5 = 0
 Else
 GoSub RS232_out
 INTCON.7 = 1
EndIf
If Key = 11 And Pusk = 0 Then GoTo format         '    
'If Key = 1 And Pusk = 0 Then GoSub Tok_komp
If Key = 0 And Pusk = 0 Then  Inc Napr                     '   
GoTo k1

'*****************************
'  
'*****************************
Rabota:
Print At 3,4,Dec3 A
If Napr = 1 Then                  
 Print At 3,11,">"
 Else
 Print At 3,11,"<"
EndIf
If T_i_p >= T_imp Then Pusk = 0: INTCON.5 = 0
Print At 3,16,Dec2 minut
Print At 3,19,Dec2 sek
GoSub KeyPad:
If Key <> 12 Then DelayMS 260
If Key = 5 Then
 Key = 12: Pusk = 0: INTCON.5 = 0
 GoSub RS232_out
EndIf
If Konec = 0 And Reg = 1 Then Key = 12:  GoTo Komp
'If Konec = 0 And Reg = 21 Then GoTo Avt_dv
'If Konec = 0 And Reg = 22 Then GoTo Avt_odn 
'If Konec = 0 And Reg = 31 Then GoTo P_avt_dv
'If Konec = 0 And Reg = 32 Then GoTo P_avt_odn 
'If Konec = 0 And Reg = 41 Then GoTo Odnp_avt
'If Konec = 0 And Reg = 42 Then GoTo P_avt_odn
GoTo Rabota
 
'***************************************
'*              43.5 
'***************************************
KeyPad:
Key = 12
 HorA = 0 : HorB = 1 : HorC = 1 : HorD = 1   ' 1   .  A,   - 0
 If Ver1 = 0 Then Key = 1 : GoSub Pik: Return 
 If Ver2 = 0 Then Key = 2 : GoSub Pik: Return 
 If Ver3 = 0 Then Key = 3 : GoSub Pik: Return 

HorA = 1 : HorB = 0 : HorC = 1 : HorD = 1  ' 1   .  ,   - 0
If Ver1 = 0 Then Key = 4 : GoSub Pik: Return 
If Ver2 = 0 Then Key = 5 : GoSub Pik: Return 
If Ver3 = 0 Then Key = 6 : GoSub Pik: Return 

HorA = 1 : HorB = 1 : HorC = 0 : HorD = 1   ' 1   .  ,   - 0
If Ver1 = 0 Then Key = 7 : GoSub Pik: Return 
If Ver2 = 0 Then Key = 8 : GoSub Pik: Return 
If Ver3 = 0 Then Key = 9 : GoSub Pik: Return 

HorA = 1 : HorB = 1 : HorC = 1 : HorD = 0    ' 1   .  D,   - 0
If Ver1 = 0 Then Key = 10 : GoSub Pik: Return 		' *    - 10
If Ver2 = 0 Then Key = 0 : GoSub Pik: Return       
If Ver3 = 0 Then Key = 11 : GoSub Pik: Return 		' #    - 11
HorD = 1
Key = 12 				'    
Return 

'**********************************************
'    ""
'**********************************************
Pik:
Sound PORTB.1,[105, 10]       '   ,   
'PulseOut PORTB.1, 10000         '   ,   
DelayMS 200
PORTB.1 = 0
Return

'******************
'     232
'*****************
RS232_in:
HSerIn [A, Perem]
DelayMS 1
'If Err <> 0 Then GoTo Err1
Return

'******************
'     rs232
'************************
RS232_out:
'PORTC.5 = 1
DelayMS 3
HSerOut [Perem, Reg]
'Hrsout Perem, Reg, Tok_k, T_imp, T_paus
'DelayMS 5
PORTC.5 = 0
DelayMS 1
Return

'****************************
'  
'**************************
Err1:
'If Err = 1 Then Print At 2, 5, "epepe"   ' ""
'If Err = 2 Then Print At 2, 2, "Opó coeoa"    ' " "
'If Err = 2 Then Print At 2, 2, "He cǷ"   ' " "
GoTo format
